Subject: Re: EMAC2 in ibm_newemac driver

From: Stefan Roese <[email-masked]>
Date: Thu, 2 Oct 2008 07:51:42 +0200

On Thursday 02 October 2008, vb wrote:
> I have a 460GT based system with three ethernet interfaces, and I
> don't seem to be able to bring up EMAC2 in RGMII mode. The PHY works
> just fine, the counterpart on the other side of the serdes link
> autonegotiates successfully, etc. When I attempt to send something
> from the interface though, nothing shows up on the RGMII lines (I use
> a scope to probe it). The received traffic is passed from the  PHY to
> the MAC, but again, nothing is reported by the rx driver.
>
> I am using the latest released code from 2.6.26.5 (I started with
> 2.6.25 release, and in that case just EMAC0 worked, updgrading to to
> 2.6.26.5 made the second interface work, but the third one seems to be
> stuck. I see that the Denx tree has a lot of changes in the driver,
> but it is not as cleanly portable, so advancing  there is not an
> option.

The ibm_newemac driver in the DENX repository has absolutely no changes to the 
kernel.org version.

> I am trying to debug it, but  am wondering if anyone had more than two
> interfaces going on this architecture and if so - what are the
> gotchas.

The AMCC Glacier 460GT eval board uses all 4 EMAC's with RGMII. IIRC, then you 
need to configure the GPIO multiplexing differently (compared to Canyonlands 
460EX) to fully support all 4 EMAC's on 460GT. This is done in U-Boot. I 
suggest that you check this configuration first.

Best regards,
Stefan